;-------------------------------------------------------------------------------------
;PRODUCT NAME : RammyAVR
;2011/11/02
;Minami Youichi
;DEVICE : ATmega48/88/168
;FUSE BITS: HIGH(0b11011111), LOW(0b11100000)
;
;-------------------------------------------------------------------------------------
.INCLUDE "m88def.inc"
.INCLUDE "RammyAVR.inc"
;-------------------------------------------------------------------------------------
;Zbg荞
RESET:
	;-----------------------------------------------------------------------------
	CLI
	LDI	 R16,LOW(RAMEND) 	;RAMŏIAhX擾
	LDI	 R17,HIGH(RAMEND)
	OUT	 SPL,R16	 	;SP
	OUT	 SPH,R17	 	;SP
	;-----------------------------------------------------------------------------
	;iȂ
WDT_OFF:
	WDR
	IN	R16, MCUSR
	ANDI	R16, (0xFF & (0 << WDRF))
	OUT	MCUSR, R16
	LDS	R16, WDTCSR
	ORI	R16, (1 << WDCE) | (1 << WDE)
	STS	WDTCSR, R16
	LDI	R16, (0 << WDE)
	STS	WDTCSR, R16
	;-----------------------------------------------------------------------------
RESET_PORT:
	;|[gB
	;o͕ݒ, 1=o̓s, 0=̓s
	LDI	R16,	(0 << PN_OSC) | (0 << PN_WR) | (0 << PN_RD) | (0x0F << PN_DATA)
	OUT	DDRB,	R16
	;o͐ݒ, 1=vAbv/H, 0=Z/L
	LDI	R16,	(0 << PN_OSC) | (1 << PN_WR) | (1 << PN_RD) | (0x09 << PN_DATA)
	OUT	PORTB,	R16

	;|[gC
	;o͕ݒ, 1=o̓s, 0=̓s
	LDI	R16,	(0 << PN_RESET) | (0 << PN_SCL) | (0 << PN_SDA) | (0 << PN_BAUD1) | (0 << PN_BAUD0) | (3 << 2)
	OUT	DDRC,	R16
	;o͐ݒ, 1=vAbv/H, 0=Z/L
	LDI	R16,	(1 << PN_RESET) | (1 << PN_SCL) | (1 << PN_SDA) | (1 << PN_BAUD1) | (1 << PN_BAUD0) | (3 << 2)
	OUT	PORTC,	R16

	;|[gD
	;o͕ݒ, 1=o̓s, 0=̓s
	LDI	R16,	(0 << PN_RXD) | (1 << PN_TXD) | (1 << PN_RTS) | (0 << PN_CTS) | (0 << PN_OSC1) | (0 << PN_OSC0)
	OUT	DDRD,	R16
	;o͐ݒ, 1=vAbv/H, 0=Z/L
	LDI	R16,	(0 << PN_RXD) | (0 << PN_TXD) | (0 << PN_RTS) | (0 << PN_CTS) | (1 << PN_OSC1) | (1 << PN_OSC0)
	;LDI	R16,	(0 << PN_RXD) | (0 << PN_TXD) | (1 << PN_RTS) | (0 << PN_CTS) | (1 << PN_OSC1) | (1 << PN_OSC0)
	OUT	PORTD,	R16
	;-----------------------------------------------------------------------------
	;SRAMNA		SRAM = 0x400 (1024) bytes
RESET_CLR:
	LDI	ZL,	LOW(SRAM_START)	;SRAM擪AhX
	LDI	ZH,	HIGH(SRAM_START)
	CLR	R16
RC100:
	ST	Z+,	R16
	CPI	ZL,	LOW(RAMEND)
	BRNE	RC100
	CPI	ZH,	HIGH(RAMEND)
	BRNE	RC100
	;-----------------------------------------------------------------------------
	;SRAM̏l
RESET_VALUE:
	CLR	R16
	STS	D_RXD_PC, R16	;PCMf[^̐[ʒu, PC <= MD
	STS	D_RXD_MD, R16	;MDǂ񂾃f[^̐[ʒu
	STS	D_TXD_PC, R16	;PC֑f[^̐[ʒu
	STS	D_TXD_MD, R16	;MD痈f[^̐[ʒu, MD <= PC
	STS	D_CMD, R16	;R}h
	STS	D_CMD_WR, R16	;R}h݈ʒu
	LDI	R16, 0x09
	STS	D_CMD_RD, R16	;R}h̎s, KhCuǂݎl
	;Mobt@[
	LDI	ZL,  LOW(D_RXD)
	LDI	ZH, HIGH(D_RXD)
	LDI	R16, SIZE_RXD
	CLR	R17
RV100:	ST	Z+, R17
	DEC	R16
	BRNE	RV100
	;Mobt@[
	LDI	ZL,  LOW(D_TXD)
	LDI	ZH, HIGH(D_TXD)
	LDI	R16, SIZE_TXD
	CLR	R17
RV200:	ST	Z+, R17
	DEC	R16
	BRNE	RV200
	;-----------------------------------------------------------------------------
	;UART
RESET_UART:
	RCALL	SET_BAUD
	;2{
	LDI	R16, (1 << U2X0) | (1 << UDRE0)
	STS	UCSR0A,	R16
	;M, M, M荞݋, M荞݋
	LDI	R16, (1 << RXEN0) | (1 << TXEN0) | (1 << RXCIE0) | (0 << TXCIE0)
	STS	UCSR0B,	R16
	;-----------------------------------------------------------------------------
	;s荞݋
RESET_INT:
	;PB4 = PCMSK0.PCINT4, PB5 = PCMSK0.PCINT5
	LDI	R16, (1 << PCIE0)
	STS	PCICR, R16
	LDI	R16, (1 << PCINT5) | (1 << PCINT4)
	STS	PCMSK0, R16
	;-----------------------------------------------------------------------------
	;S荞݋
RESET_FINAL:
	SEI
;-------------------------------------------------------------------------------------
;C[v
MAIN:
	RCALL	UART_TXC_CHK
	RJMP	MAIN
;-------------------------------------------------------------------------------------
;{[[gݒ
SET_BAUD:
	;BAUDsǂ
	IN	R16, PINC
	ANDI	R16, (1 << PN_BAUD1) | (1 << PN_BAUD0)
	STS	D_BAUD_KBPS, R16
	;-----------------------------------------------------------------------------
	;OSCsǂ
	IN	R17, PIND
	ANDI	R17, (1 << PN_OSC1) | (1 << PN_OSC0)
	SWAP	R17		;0b11000000  0b00001100
	MOV	R18, R17
	LSR	R18
	LSR	R18		;0b00001100  0b00000011
	INC	R18
	STS	D_OSC_MHZ, R18
	;-----------------------------------------------------------------------------
	;OSCsBAUDs̏Ԃɂ镪}
	OR	R16, R17
	CLR	R17
	LDI	ZL,  LOW(D_OSC_BAUD << 1)
	LDI	ZH, HIGH(D_OSC_BAUD << 1)
	ADD	ZL, R16
	ADC	ZH, R17
	LPM	R16, Z
	;-----------------------------------------------------------------------------
	;{[[gZbg
	STS	UBRR0H,	R17
	STS	UBRR0L,	R16
	;-----------------------------------------------------------------------------
	RET
;-------------------------------------------------------------------------------------
;RTSt[
RTS:	;MFIFOȏ㖄܂ĂȂRTS
	LDS	R16, D_RXD_PC
	LDS	R17, D_RXD_MD
	SUB	R16, R17
	CPI	R16, (SIZE_RXD / 2)
	BRSH	R100	;i((PC - MD) >= 64) goto R100;
	SBI	PORTD, PN_RTS	;RTS = M\
	;CBI	PORTD, PN_RTS	;RTS = M\
	RET
R100:	CBI	PORTD, PN_RTS	;RTS = Ms
	;SBI	PORTD, PN_RTS	;RTS = Ms
	RET
;-------------------------------------------------------------------------------------
;VAM`FbN
UART_TXC_CHK:
	;-----------------------------------------------------------------------------
	;PCRTSĂȂ瑗MȂ
	SBIS	PIND, PN_CTS	;1ŃXLbv
	;SBIC	PIND, PN_CTS	;0ŃXLbv
	BREQ	UTC_END
	;-----------------------------------------------------------------------------
	;UARTMobt@[󂢂ĂȂȂI
UTC_00:	LDS	R16, UCSR0A
	ANDI	R16, (1 << UDRE0)
	BREQ	UTC_END
	;-----------------------------------------------------------------------------
	;FIFO PC != MD Ȃ瑗M
	LDS	R16, D_TXD_PC
	LDS	R17, D_TXD_MD
	CP	R16, R17
	BREQ	UTC_END		; if(PC == MD) goto TX_END;
	;MWX^[ɑMf[^Zbg
	LDI	ZL,  LOW(D_TXD)
	LDI	ZH, HIGH(D_TXD)
	CLR	R17
	ADD	ZL, R16
	ADC	ZH, R17
	LD	R18, Z
	STS	UDR0, R18
	INC	R16
	ANDI	R16, 0x7F
	STS	D_TXD_PC, R16
UTC_END:
	RET
;-------------------------------------------------------------------------------------
EXT_INT0:	 ;O荞ݗv0

	RETI
;-------------------------------------------------------------------------------------
EXT_INT1:	 ;O荞ݗv1

	RETI
;-------------------------------------------------------------------------------------
PC_INT0:	 ;sω荞ݗv0
	PUSH	R15
	IN	R15, SREG
	PUSH	R16
	PUSH	R17
	PUSH	R18
	PUSH	ZL
	PUSH	ZH
	;-----------------------------------------------------------------------------
	;t[
	RCALL	RTS
	;-----------------------------------------------------------------------------
	;!RDsオĂI
	IN	R16, PINB
	ANDI	R16, (1 << PN_RD)
	BRNE	RD_END
	;DATAso͂ɂ
	IN	R16, DDRB
	SBR	R16, (0x0F << PN_DATA)
	OUT	DDRB, R16
	;R}h̎sʂo͂
	LDS	R16, D_CMD_RD
	ANDI	R16, 0x0F
	IN	R17, PORTB
	CBR	R17, (0x0F << PN_DATA)
	OR	R17, R16
	OUT	PORTB, R17
	;̃R}h̎sʂpӂď㏑
	LDS	R16, D_CMD_RD
	SWAP	R16
	STS	D_CMD_RD, R16
	RJMP	WR_CHK
RD_END:
	;DATAs͂ɂ
	IN	R16, DDRB
	CBR	R16, (0x0F << PN_DATA)
	OUT	DDRB, R16
	;DATAsvAbv
	IN	R16, PORTB
	ORI	R16, (0x0F << PN_DATA)
	OUT	PORTB, R16
	;-----------------------------------------------------------------------------
	;!WRsオĂI
WR_CHK:	IN	R16, PINB
	ANDI	R16, (1 << PN_WR)
	BRNE	WR_END
	;DATAs͂ɂ
	IN	R16, DDRB
	CBR	R16, (0x0F << PN_DATA)
	OUT	DDRB, R16
	;DATAǂ
	IN	R16, PINB
	ANDI	R16, (0x0F << PN_DATA)	;Vtg͗vȂ
	;R}hzɏ
	LDI	ZL,  LOW(D_CMD)
	LDI	ZH, HIGH(D_CMD)
	LDS	R17, D_CMD_WR
	CLR	R18
	ADD	ZL, R17
	ADC	ZH, R18
	ST	Z, R16
	;R}h݈ʒuCNg
	INC	R17
	STS	D_CMD_WR, R17
	;R}hz3vfR}hs
	LDI	R18, 1
	LDS	R16, (D_CMD + 0)
	CPI	R16, 8
	BRLO	WR_100	;if(R16 < 8) goto WR_100
	SUBI	R18, -2
WR_100:	CP	R17, R18
	BRNE	WR_END
	;R}h݈ʒuZbg
	CLR	R17
	STS	D_CMD_WR, R17
	;R}hƈ[h
	LDS	R16, (D_CMD + 0)
	LDS	R17, (D_CMD + 1)
	LDS	R18, (D_CMD + 2)
	SWAP	R18
	ANDI	R18, 0xF0
	OR	R17, R18
	STS	(D_CMD + 1), R17
	;R}h̏Ɉڂ
	CPI	R16, C_RXD
	BREQ	CMD_RXD
	CPI	R16, C_TXD
	BREQ	CMD_TXD
	CPI	R16, C_OSC
	BREQ	CMD_OSC
	CPI	R16, C_BAUD
	BREQ	CMD_BAUD
WR_END:
	;-----------------------------------------------------------------------------
	POP	ZH
	POP	ZL
	POP	R18
	POP	R17
	POP	R16
	OUT	SREG, R15
	POP	R15
	RETI
;-------------------------------------------------------------------------------------
;Mf[^ǂݎR}h
CMD_RXD:
	;ftHglZbg
	LDI	R16, 0x00
	STS	D_CMD_RD, R16
	;-----------------------------------------------------------------------------
	;ǂݏof[^I
	LDS	R16, D_RXD_MD
	LDS	R17, D_RXD_PC
	CP	R16, R17
	BREQ	WR_END		;if(MD == PC) goto WR_END;
	;-----------------------------------------------------------------------------
	;Mf[^ǂݏo
	LDI	ZL,  LOW(D_RXD)
	LDI	ZH, HIGH(D_RXD)
	CLR	R17
	ADD	ZL, R16
	ADC	ZH, R17
	INC	R16
	ANDI	R16, 0x7F
	STS	D_RXD_MD, R16
	LD	R16, Z
	;-----------------------------------------------------------------------------
	;Mf[^R}h̎sʂɏ
	STS	D_CMD_RD, R16
	RJMP	WR_END
;-------------------------------------------------------------------------------------
;Mf[^݃R}h
CMD_TXD:
	;FIFŐ󂫂AsʂɑMۂZbgāAI
	LDI	R18, FALSE	;s = M
	STS	D_CMD_RD, R18
	;
	LDS	R17, D_TXD_PC
	LDS	R16, D_TXD_MD
	DEC	R17		;PC--;
	SUB	R17, R16	;PC(2) - MD(3) = 127,  PC(120) - MD(3) = 117, PC(6) - MD(3) = 3, PC(2) - MD(126) = 4, 
	ANDI	R17, 0x7F
	CPI	R17, 64
	BRLO	WR_END		;if((PC - MD) < 64) goto WR_END;
	;
	LDI	R18, TRUE	;s = M
	STS	D_CMD_RD, R18
	;-----------------------------------------------------------------------------
	;MFIFÕ|C^[ݒ肷
	LDI	ZL,  LOW(D_TXD)
	LDI	ZH, HIGH(D_TXD)
	CLR	R17
	ADD	ZL, R16
	ADC	ZH, R17
	INC	R16
	ANDI	R16, 0x7F
	STS	D_TXD_MD, R16
	;-----------------------------------------------------------------------------
	;Mf[^𑗐MFIFOɏ
	LDS	R16, (D_CMD + 1)
	ST	Z, R16
	RJMP	WR_END
;-------------------------------------------------------------------------------------
;IV[^[NbNǂݎR}h
CMD_OSC:
	LDS	R16, D_OSC_MHZ
	STS	D_CMD_RD, R16
	RJMP	WR_END
;-------------------------------------------------------------------------------------
;{[[gǂݎR}h
CMD_BAUD:
	LDS	R16, D_BAUD_KBPS
	STS	D_CMD_RD, R16
	RJMP	WR_END
;-------------------------------------------------------------------------------------
PC_INT1:	 ;sω荞ݗv1

	RETI
;-------------------------------------------------------------------------------------
PC_INT2:	 ;sω荞ݗv2

	RETI
;-------------------------------------------------------------------------------------
WDT_OVF:	 ;WDT v

	RETI
;-------------------------------------------------------------------------------------
TIM2_COMPA:	 ;Timer/Counter2 rAv

	RETI
;-------------------------------------------------------------------------------------
TIM2_COMPB:	 ;Timer/Counter2 rBv

	RETI
;-------------------------------------------------------------------------------------
TIM2_OVF:	 ;Timer/Counter2 I[o[t[

	RETI
;-------------------------------------------------------------------------------------
TIM1_CAPT:	 ;Timer/Counter1 ߊl()

	RETI
;-------------------------------------------------------------------------------------
TIM1_COMPA:	 ;Timer/Counter1 rAv

	RETI
;-------------------------------------------------------------------------------------
TIM1_COMPB:	 ;Timer/Counter1 rBv

	RETI
;-------------------------------------------------------------------------------------
TIM1_OVF:	 ;Timer/Counter1 I[o[t[

	RETI
;-------------------------------------------------------------------------------------
TIM0_COMPA:	 ;Timer/Counter0 rAv

	RETI
;-------------------------------------------------------------------------------------
TIM0_COMPB:	 ;Timer/Counter0 rBv

	RETI
;-------------------------------------------------------------------------------------
TIM0_OVF:	 ;Timer/Counter0 I[o[t[

	RETI
;-------------------------------------------------------------------------------------
SPI_STC:	 ;SPI]

	RETI
;-------------------------------------------------------------------------------------
USART_RXC:	 ;USART M
	PUSH	R15
	IN	R15, SREG
	PUSH	R16
	PUSH	R17
	PUSH	R18
	PUSH	ZL
	PUSH	ZH
	;-----------------------------------------------------------------------------
	;t[
	RCALL	RTS
	;-----------------------------------------------------------------------------
	;MFIFO PC != (MD - 1) ȂM
	LDS	R16, D_RXD_PC
	LDS	R17, D_RXD_MD
	DEC	R17
	CP	R16, R17
	BREQ	UR_END		; if(PC == (MD - 1)) goto RX_END;
	;MWX^[ǂŎMFIFOɃZbg
	LDI	ZL,  LOW(D_RXD)
	LDI	ZH, HIGH(D_RXD)
	CLR	R17
	ADD	ZL, R16
	ADC	ZH, R17
	INC	R16
	ANDI	R16, 0x7F
	STS	D_RXD_PC, R16
	LDS	R18, UDR0
	ST	Z, R18
UR_END:
	;-----------------------------------------------------------------------------
	POP	ZH
	POP	ZL
	POP	R18
	POP	R17
	POP	R16
	OUT	SREG, R15
	POP	R15
	RETI
;-------------------------------------------------------------------------------------
USART_UDRE:	 ;USART MBUFFER 

	RETI
;-------------------------------------------------------------------------------------
USART_TXC:	 ;USART M

	RETI
;-------------------------------------------------------------------------------------
ADCCOMP:	 ;ADCϊ 

	RETI
;-------------------------------------------------------------------------------------
EE_RDY:	 ;EEPROM 

	RETI
;-------------------------------------------------------------------------------------
ANA_COMP:	 ;ANALOGr o͑J

	RETI
;-------------------------------------------------------------------------------------
TWI:	 ;2SPI ԕω

	RETI
;-------------------------------------------------------------------------------------
SPM_RDY:	 ;SPMߑ

	RETI
;-------------------------------------------------------------------------------------
.EXIT